<template>
  <div>
    <div class="fr-mb-5w">
      <FrTitle larger>Recrutement</FrTitle>
      <FrSubTitle>
        Nous accompagnons les territoires vers leur transition numérique le plus
        simplement possible.
      </FrSubTitle>
      <a
        class="fr-text-title--blue-france"
        href="https://beta.gouv.fr/recrutement"
        target="_blank"
        title="Consulter les offres d'emploi de la communauté Beta.gouv.fr"
        rel="noopener"
        @click="trackOutLink('https://beta.gouv.fr/recrutement')"
      >
        Consulter toutes les offres de la communauté Beta.gouv.fr
      </a>
    </div>

    <FrCardsContainer>
      <FrCard
        v-for="(card, index) in cards"
        :key="`recruitment-card${index}`"
        class="fr-col-12"
        :title="card.title"
        :to="card.to"
        :description="card.description"
        :detail="card.detail"
        horizontal
        enlarge-link
      />
    </FrCardsContainer>
  </div>
</template>

<script>
import FrTitle from '~/components/ui/Title';
import FrSubTitle from '~/components/ui/SubTitle';
import FrCard from '~/components/elements/Card';
import FrCardsContainer from '~/components/elements/CardsContainer';
import { trackOutLink } from '~/tools/matomo';

export default {
  name: 'RecruitmentPage',

  components: {
    FrSubTitle,
    FrTitle,
    FrCard,
    FrCardsContainer,
  },

  async asyncData({ $axios }) {
    const { data: offers } = await $axios.$get('/items/offres_emploi', {
      params: {
        fields:
          'job_title,slug,contract_type,organization,date_created,publication_date',
        filter: { status: { _eq: 'published' } },
      },
    });

    const cards = offers
      .map(
        ({
          slug,
          job_title,
          contract_type,
          organization,
          date_created,
          publication_date,
        }) => {
          const elapsedTime = Math.abs(
            new Date() - new Date(publication_date || date_created),
          );
          const elapsedDays = Math.floor(elapsedTime / (1000 * 3600 * 24));

          let creationDurationToDisplay;

          if (elapsedDays < 1) {
            creationDurationToDisplay = "Aujourd'hui";
          } else if (elapsedDays === 1) {
            creationDurationToDisplay = 'Hier';
          } else if (elapsedDays <= 30) {
            creationDurationToDisplay = `Il y a ${elapsedDays} jours`;
          } else {
            creationDurationToDisplay = `Il y a ${Math.floor(
              elapsedDays / 30,
            )} mois`;
          }

          return {
            title: job_title,
            to: { name: 'recrutement-slug', params: { slug } },
            detail: organization,
            description: `${creationDurationToDisplay} · ${contract_type}`,
            elapsedTime,
          };
        },
      )
      .sort((a, b) => a.elapsedTime > b.elapsedTime);

    return {
      cards,
    };
  },

  data() {
    return {
      cards: [],
    };
  },

  head() {
    return {
      title: 'Incubateur des territoires - Recrutement',
    };
  },
  methods: {
    trackOutLink,
  },
};
</script>
